#include <bits/stdc++.h>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<vector<char>> g(n, vector<char>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> g[i][j];
        }
    }
    pair<int, int> s, f;
    cin >> s.first >> s.second >> f.first >> f.second;
    --s.first;
    --s.second;
    --f.first;
    --f.second;
    deque<pair<int, int>> q;
    vector<vector<int>> dist(n, vector<int>(m, (int)1e7));
    q.emplace_back(s);
    dist[s.first][s.second] = 0;
    vector<pair<pair<int, int>, int>> moves = {
        { { -1, 0 }, 0 },
        { { 0, -1 }, 0 },
        { { 1, 0 }, 0 },
        { { 0, 1 }, 0 },
        { { -2, 0 }, 1 },
        { { 0, -2 }, 1 },
        { { 2, 0 }, 1 },
        { { 0, 2 }, 1 }
    };
    auto is_in_range = [](int x, int r) {
        return x >= 0 && x < r;
    };
    auto check = [n, m, &g, &is_in_range](pair<int, int> p) {
        return is_in_range(p.first, n) && is_in_range(p.second, m) && g[p.first][p.second] == '.';
    };
    while (!q.empty()) {
        pair<int, int> cur = q.front();
        q.pop_front();
        for (const auto &i : moves) {
            pair<int, int> nxt(cur.first + i.first.first, cur.second + i.first.second);
            if (check(nxt) && dist[nxt.first][nxt.second] > dist[cur.first][cur.second] + i.second) {
                if (i.second) {
                    q.emplace_back(nxt);
                }
                else {
                    q.emplace_front(nxt);
                }
                dist[nxt.first][nxt.second] = dist[cur.first][cur.second] + i.second;
            }
        }
    }
    cout << (dist[f.first][f.second] <= k ? "YES" : "NO") << '\n';
    return 0;
}