#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void count(int n, int k, vector <int>& ch, int sum = 0) {
	if (n == 0) {
		ch[sum]++;
		return;
	}
	for (int i = 1; i <= k; i++)
		count(n - 1, k, ch, sum + i);
}

int main() {
	int n, k, s1, s2;
	cin >> n >> k >> s1 >> s2;
	
	vector <int> ch(max(n * k, max(s1, s2)) + 1);
	count(n, k, ch);
	
	if (ch[s1] == ch[s2]) cout << "Equal";
	else if (ch[s1] < ch[s2]) cout << "Second";
	else cout << "First";
	
	return 0;
}