/**
 *    author:  tourist
 *    created: 13.10.2023 01:04:11       
**/
#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<long long> x(n), y(n);
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
  }
  vector<long long> d(n);
  for (int i = 0; i < n; i++) {
    int j = (i + 1) % n;
    auto dx = x[i] - x[j];
    auto dy = y[i] - y[j];
    d[i] = sqrt(dx * dx + dy * dy);
  }
  cout << fixed << setprecision(17) << accumulate(d.begin(), d.end(), 0.0) - *max_element(d.begin(), d.end()) << '\n';
  return 0;
}
