#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
using ll = long long;

unordered_map<string, int> previous_counter;
unordered_map<string, unordered_set<ll>> numbers_suffix;

void solve()
{
    int q;
    cin >> q;
    while (q--) {
        string name;
        cin >> name;
        auto& counter = previous_counter[name];
        ll number = 0, pow10 = 1;
        while (name.size() && isdigit(name.back())) {
            number += (name.back() - '0') * pow10;
            pow10 *= 10;
            name.pop_back();
        }
        pow10 = 1;
        while (pow10 <= counter)
            pow10 *= 10;
        auto& numbers_list = numbers_suffix[name];
        while (true) {
            const auto try_add = number * pow10 + counter;
            ++counter;
            if (counter == pow10)
                pow10 *= 10;
            if (numbers_list.insert(try_add).second) {
                cout << name;
                if (try_add)
                    cout << try_add;
                cout << endl;
                break;
            }
        }
    }
}

int main()
{
#ifndef ONLINE_JUDGE
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif // MY
    previous_counter.reserve(1e6);
    numbers_suffix.reserve(1e6);
    solve();
}
